/*
 * config.h
 *
 *  Created on: Sep 5, 2021
 *      Author: dukenuc
 */

#ifndef INC_CONFIG_H_
#define INC_CONFIG_H_

/* TODO: add comments to everything */

#include "stdint.h"

#define VENDOR_NAME_LENGTH			64
#define	PRODUCT_CODE_LENGTH			64
#define	PRODUCT_NAME_LENGTH			64
#define REVISION_LENGTH				16
#define SERIAL_NUMBER_LENGTH		64

#define CONFIG_OK					0
#define CONFIG_ERROR				-1


typedef struct
{
	/* DEVICE ID */
	uint8_t vendor_name[VENDOR_NAME_LENGTH];
	uint8_t product_code[PRODUCT_CODE_LENGTH];
	uint8_t product_name[PRODUCT_NAME_LENGTH];
	uint8_t revision[REVISION_LENGTH];
	uint8_t serial_number[SERIAL_NUMBER_LENGTH];

	/* DEVICE SPECIFIC CONFIG */
	uint8_t led_on;
	uint16_t led_co2_alert_limit1;
	uint16_t led_co2_alert_limit2;
} config_t;

int8_t read_config(config_t *config);

int8_t write_config(config_t *config);

#endif /* INC_CONFIG_H_ */

